/* EEE4084F Lecture 20 Class Activity 

   Implementation of pattern counter

   Handle-C style solution.
*/

#include <stdlib.h>
#include <stdio.h>
#include "handlec.h"

void PC (
  _in unsigned* start_input,
  _in unsigned* end_input,
  _in unsigned short pat_input,
  _in bit enable,
  _out bit& done,
  _out unsigned short& found_out
  )
{
  static bit prev_enable = 0;
  static unsigned short pat;
  static unsigned short found;
  static unsigned* start;
  static unsigned* end;

  if (prev_enable != enable) {
     prev_enable = enable;
     printf("toggle!\n");
     if (enable) {
        pat = pat_input; // store the patter to look for
        start = start_input;
        end = end_input;
        done = 0;
        found = 0;
        return; // the function will immeduately go back to its start when exited
        }
     }
  if (!enable) return;
  // check if we are at the end yet
  if (start == end) {
     found_out = found;
     done = 1; // signal that processing is complete
     return;
  }
  unsigned x = *start;
  if ((x&0xFFFF) == pat) found++; // check low order half word
  if ((x>>16)    == pat) found++; // check high order half word
    printf("%x  found=%d\n",x,found);
  start = start + 1; // move on to the next memory address
  // when the function exists, it just goes back to the start
}


int main ()
{
   unsigned data[8] = {
            0xFFFF0000, 0xFF000032, 0xF0000032, 0xFF00FF00,
            0xEDE07001, 0x00320010, 0xD0D00001, 0xFF00FFFF};
   bit done = 0;
   unsigned short found = 0;
   PC(data,data+7,0x0032,0,done,found); printf("done = %d found=%d\n",(int)done,found);
   PC(data,data+7,0x0032,1,done,found); printf("done = %d found=%d\n",(int)done,found);
   for (int i=0; i<10; i++) {
     PC(data,data+7,0,1,done,found);
     printf("done = %d found=%d\n",(int)done,found);
    }
   system("PAUSE");
   return 0;
}


